Package net.sf.saxon.tree.tiny

## Class TinyBuilder

- java.lang.Object
- - net.sf.saxon.event.Builder
  - - net.sf.saxon.tree.tiny.TinyBuilder

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`
  Direct Known Subclasses:
    `TinyBuilderCondensed`

      public class TinyBuilder
      extends Builder

  The TinyBuilder class is responsible for taking a stream of SAX events and constructing a Document tree, using the "TinyTree" implementation.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.Builder

      `AXIOM_TREE, baseURI, config, currentRoot, DOMINO_TREE, JDOM_TREE, JDOM2_TREE, lineNumbering, LINKED_TREE, MUTABLE_LINKED_TREE, namePool, open, pipe, started, systemId, timing, TINY_TREE, TINY_TREE_CONDENSED, uniformBaseURI, UNSPECIFIED_TREE_MODEL, useEventLocation`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TinyBuilder​(PipelineConfiguration pipe)` | Create a TinyTree builder

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `characters​(java.lang.CharSequence chars, Location locationId, int properties)` | Notify a text node
    `void` | `close()` | Notify the end of the event stream
    `void` | `comment​(java.lang.CharSequence chars, Location locationId, int properties)` | Callback interface for SAX: not for application use
    `void` | `endDocument()` | Callback interface for SAX: not for application use
    `void` | `endElement()` | Notify the end of an element node
    `protected java.lang.String` | `getAttValue​(AttributeInfo att)` |
    `BuilderMonitor` | `getBuilderMonitor()` | Get a builder monitor for this builder.
    `int` | `getCurrentDepth()` | Get the current depth in the tree
    `TinyNodeImpl` | `getLastCompletedElement()` | Get the last completed element node.
    `TinyTree` | `getTree()` | Get the tree being built by this builder
    `protected int` | `makeTextNode​(java.lang.CharSequence chars, int len)` | Create a text node.
    `void` | `open()` | Open the event stream
    `void` | `processingInstruction​(java.lang.String piname, java.lang.CharSequence remainder, Location locationId, int properties)` | Callback interface for SAX: not for application use
    `void` | `reset()` | Reset the builder to its initial state.
    `void` | `setStatistics​(Statistics stats)` | Set the size parameters for the tree
    `void` | `setUnparsedEntity​(java.lang.String name, java.lang.String uri, java.lang.String publicId)` | Set an unparsed entity in the document
    `void` | `startDocument​(int properties)` | Write a document node to the tree
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element

    - ### Methods inherited from class net.sf.saxon.event.Builder

      `getBaseURI, getConfiguration, getCurrentRoot, getPipelineConfiguration, getSystemId, isTiming, isUseEventLocation, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming, setUseEventLocation, usesTypeAnnotations`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `append, append, handlesAppend`

- - ### Constructor Detail

    - #### TinyBuilder

          public TinyBuilder​(PipelineConfiguration pipe)

      Create a TinyTree builder
      Parameters:
        `pipe` - information about the pipeline leading up to this Builder

  - ### Method Detail

    - #### setStatistics

          public void setStatistics​(Statistics stats)

      Set the size parameters for the tree
      Parameters:
        `stats` - an object holding the expected number of non-attribute nodes, the expected number of attributes, the expected number of namespace declarations, and the expected total length of character data

    - #### getTree

          public TinyTree getTree()

      Get the tree being built by this builder
      Returns:
        the TinyTree

    - #### getCurrentDepth

          public int getCurrentDepth()

      Get the current depth in the tree
      Returns:
        the current depth

    - #### open

          public void open()

      Open the event stream
      Specified by:
        `open` in interface `Receiver`
      Overrides:
        `open` in class `Builder`

    - #### startDocument

          public void startDocument​(int properties)
                             throws XPathException

      Write a document node to the tree
      Parameters:
        `properties` -
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Callback interface for SAX: not for application use
      Throws:
        `XPathException` - if an error occurs

    - #### reset

          public void reset()

      Description copied from class: `Builder`
      Reset the builder to its initial state. The most important effect of calling this method (implemented in subclasses) is to release any links to the constructed document tree, allowing the memory occupied by the tree to released by the garbage collector even if the Builder is still in memory. This can happen because the Builder is referenced from a parser in the Configuration's parser pool.
      Overrides:
        `reset` in class `Builder`

    - #### close

          public void close()
                     throws XPathException

      Description copied from interface: `Receiver`
      Notify the end of the event stream
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `Builder`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Notify the start of an element
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### getAttValue

          protected java.lang.String getAttValue​(AttributeInfo att)

    - #### endElement

          public void endElement()
                          throws XPathException

      Notify the end of an element node
      Throws:
        `XPathException` - if an error occurs

    - #### getLastCompletedElement

          public TinyNodeImpl getLastCompletedElement()

      Get the last completed element node. This is used during checking of schema assertions, which happens while the tree is still under construction. It is also used when copying accumulator values to the new tree from a streamed input. This method is called immediately after a call on endElement(), and it returns the element that has just ended.
      Returns:
        the last completed element node, that is, the element whose endElement event is the most recent endElement event to be reported, or null if there is no such element

    - #### characters

          public void characters​(java.lang.CharSequence chars,
                                 Location locationId,
                                 int properties)
                          throws XPathException

      Notify a text node
      Parameters:
        `chars` - The characters
        `locationId` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### makeTextNode

          protected int makeTextNode​(java.lang.CharSequence chars,
                                     int len)

      Create a text node. Separate method so it can be overridden. If the current node on the tree is already a text node, the new text will be appended to it.
      Parameters:
        `chars` - the contents of the text node
        `len` - the length of the text node
      Returns:
        the node number of the created text node, or the text node to which this text has been appended.

    - #### processingInstruction

          public void processingInstruction​(java.lang.String piname,
                                            java.lang.CharSequence remainder,
                                            Location locationId,
                                            int properties)
                                     throws XPathException

      Callback interface for SAX: not for application use
      Parameters:
        `piname` - The PI name. This must be a legal name (it will not be checked).
        `remainder` - The data portion of the processing instruction
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.
      Throws:
        `XPathException` - if an error occurs

    - #### comment

          public void comment​(java.lang.CharSequence chars,
                              Location locationId,
                              int properties)
                       throws XPathException

      Callback interface for SAX: not for application use
      Parameters:
        `chars` - The content of the comment
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.
      Throws:
        `XPathException` - if an error occurs

    - #### setUnparsedEntity

          public void setUnparsedEntity​(java.lang.String name,
                                        java.lang.String uri,
                                        java.lang.String publicId)

      Set an unparsed entity in the document
      Parameters:
        `name` - The name of the unparsed entity
        `uri` - The system identifier of the unparsed entity
        `publicId` - The identifier of the unparsed entity

    - #### getBuilderMonitor

          public BuilderMonitor getBuilderMonitor()

      Description copied from class: `Builder`
      Get a builder monitor for this builder. This must be called immediately after opening the builder, and all events to the builder must thenceforth be sent via the BuilderMonitor.
      Overrides:
        `getBuilderMonitor` in class `Builder`
      Returns:
        a new BuilderMonitor appropriate to this kind of Builder; or null if the Builder does not provide this service. The default implementation returns null.